# Builder

## ApplicationPrototype. Builder

#### new Builder()

Source:
  - dictionary.d.js, line 167

### Extends

- ApplicationPrototype.Instance

### Classes

Promise

### Methods

#### (static) consoleOptions(optionsopt) → {ApplicationPrototype.Builder.ConsoleOptions}

Source:
  - dictionary.d.js, line 244

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`options` | ApplicationPrototype.Builder.ConsoleOptions | <optional> |

##### Returns:

Type
  ApplicationPrototype.Builder.ConsoleOptions

#### (static) debugEnabled(statusopt) → {boolean}

Source:
  - dictionary.d.js, line 230

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`status` | boolean | <optional> |

##### Returns:

Type
  boolean

#### (static) isBrowser() → {boolean}

Source:
  - dictionary.d.js, line 224

##### Returns:

Type
  boolean

#### (static) isNode() → {boolean}

Source:
  - dictionary.d.js, line 218

##### Returns:

Type
  boolean

#### (static) modulePath(pathopt) → {string}

Source:
  - dictionary.d.js, line 251

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`path` | string | <optional> |

##### Returns:

Type
  string

#### (static) moduleRegister(path, modules) → {ApplicationPrototype.Builder.ModuleStore}

Source:
  - dictionary.d.js, line 274

##### Parameters:

Name | Type | Description
--- | --- | ---
`path` | string | path that will be used as `Application.modulePath()`
`modules` | Array.<string> | list of modules names that should be registered

##### Returns:

Type
  ApplicationPrototype.Builder.ModuleStore

#### (static) require(events, callbackopt) → {PromiseLike.<any>}

Source:
  - dictionary.d.js, line 174

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`events` | string | Array.<string> |  | List of Events Names or Array of Events Mapping like [ "uriLoad :: uri-load", "ePrototype :: ExtensionsPrototype" ]
`callback` | function | <optional> | Callback that will receive Module

##### Returns:

Type
  PromiseLike.<any>

#### (static) runModulesInFiles(statusopt) → {boolean}

Source:
  - dictionary.d.js, line 237

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`status` | boolean | <optional> |

##### Returns:

Type
  boolean

### Type Definitions

#### ApplicationModule

Source:
  - dictionary.d.js, line 685

##### Properties:

Name | Type | Description
--- | --- | ---
`$request` | PromiseLike.<XMLHttpRequest> | resolves module exports
`exports` | function | module exports handler
`atime` | number | unix time in milliseconds
`Application` | function | returns current application
`cache` | function | returns module's reserved cache object
`require` | function | require modules from module's folder
`resourceUrl` | function | returns module's resource URL
`meta` | ApplicationPrototype.Builder.ModuleMeta | module's meta information

##### Type:

- Object

#### ConsoleOptions

Source:
  - dictionary.d.js, line 258

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`file` | boolean | <optional> | enable/disable showing filename in console log. default value is `true`
`contextName` | boolean | <optional> | enable/disable showing context Execution info in console log. default value is `true`
`timestamp` | boolean | <optional> | enable/disable showing current timestamp in console log. default value is `true`
`logType` | boolean | <optional> | enable/disable showing log type in console log. default value is `true

##### Type:

- object

#### ModuleMeta

Source:
  - dictionary.d.js, line 282

##### Properties:

Name | Type | Description
--- | --- | ---
`store` | ApplicationPrototype.Builder.ModuleStore | same as `module.cache()`
`$requestQuery` | PromiseLike.<string> | XMLHttpRequest used for obtaining Module's Content
`module_path` | string | module's path
`path` | string | module's internal path used as identifier of module
`name` | string | module's name
`__dirname` | string | module's dirname

##### Type:

- object

#### moduleResolve(module, pathopt) → {ApplicationPrototype.Builder.ModuleMeta}

Source:
  - dictionary.d.js, line 293

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`module` | string |  | module name
`path` | string | <optional> | module path

##### Returns:

Type
  ApplicationPrototype.Builder.ModuleMeta

#### ModuleResourceUrl

Source:
  - dictionary.d.js, line 679

resources url is composed from `module's plath` + `resource path`

##### Type:

- string

#### ModuleStore

Source:
  - dictionary.d.js, line 268

modules store where are indexed modules

##### Type:

- object